#include <sourcemod>

#include "bossengine/egg.sp"
#include "bossengine/monster.sp"

#pragma semicolon 1
#pragma newdecls required

public Plugin myinfo =
{
    name        = "[ANY] Boss Engine",
    author      = "Richard 'rswallen' Allen",
    description = "An API for creating highly configurable boss players",
    version     = "1.0.4"
};

public APLRes AskPluginLoad2(Handle myself, bool late, char[] error, int err_max)
{
    Egg.Link();
    Monster.Link();
    
    RegPluginLibrary("bossengine");
    return;
}

public void OnPluginStart()
{
    Egg.Init();
    Monster.Init();
    return;
}

public void OnGameFrame()
{
    Egg.GCThink();
    Monster.GCThink();
    return;
}

public void OnClientDisconnect_Post(int client)
{
    Monster thing = GetClientMonster(client);
    if (thing != INVALID_MONSTER)
    {
        thing.Destroy();
    }
    return;
}
